# 2FA

This is only a quick demo on how you could possible generate a second factor in form of a one-time-password using Python.

If you want to manage all your second factors in one place, this tool is not for you.

A working implementation that even stores the secret somewhat securely is possible in a dozen lines of code, see the version on the tag [`initial`](https://gitlab.cl.uni-heidelberg.de/moser/2fa/-/blob/initial/main.py) for details.

## Installation

```bash
python3 -m venv venv
source venv/bin/activate
pip install -r requirements.txt
```

## Enrollment of secret

Launch a Python shell, e.g., using:

```bash
source venv/bin/activate
python3 main.py -e
```

This will only store the secret locally in the secret storage, with minimal validation.
To facilitate scripting, you can also pass the token as a quoted (!) string to the script, i.e like that:

```bash
python3 main.py -e "otpauth://totp/..."
```

## Get token

```bash
source venv/bin/activate
./main.py
```

## Deletion of secret

If you ever want to delete the token, just call the script with the `-d` argument:

⚠️ there is no confirmation of the deletion, it will just delete the token!

```bash
python3 main.py -d
```

## License

This "project" is licensed under [CC0 1.0](https://creativecommons.org/publicdomain/zero/1.0/), i.e., released to the public domain. TL;DR: You can do whatever the fuck you want to with this code, but don't hold me liable if something bad happens.
